#ifndef _COMMANDS_H
#define _COMMANDS_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "type_def.h"
#include "packet_processing.h"

// ----------------------
// Helper stuff

#define MAX_TYPE 6
#define MAX_SUBTYPE 100

enum Message{
	BEGIN_CHAR = 0xBE,
	END_CHAR   = 0xED
};

// This should also have double to avoid confusion with float values.
enum DataType
{
	floatType,
	intType,
	stringType
};

// MESSAGE SUBTYPES
struct MessageSubtype{
	char ID;
	char cmdText[100];
	char cmdDataType;
	int (*functionPtr)(modular_structs_t *structs);
};

// MESSAGE TYPES
struct MessageType{
	char ID;
	struct MessageSubtype subtypes[MAX_SUBTYPE];
};

int debug(modular_structs_t *structs);
int packetlog(modular_structs_t* structs);
int getpacketlogs(modular_structs_t* structs);
int update(modular_structs_t *structs);
int beginupdate(modular_structs_t *structs);
int logdata(modular_structs_t *structs);
int response(modular_structs_t *structs);
int yawset(modular_structs_t *structs);
int yawp(modular_structs_t *structs);
int yawd(modular_structs_t *structs);
int rollset(modular_structs_t *structs);
int rollp(modular_structs_t *structs);
int rolld(modular_structs_t *structs);
int pitchset(modular_structs_t *structs);
int pitchp(modular_structs_t *structs);
int pitchd(modular_structs_t *structs);
int throttleset(modular_structs_t *structs);
int throttlep(modular_structs_t *structs);
int throttlei(modular_structs_t *structs);
int throttled(modular_structs_t *structs);
int accelreq(modular_structs_t *structs);
int gyroresp(modular_structs_t *structs);
int pitchangleresp(modular_structs_t *structs);
int rollangleresp(modular_structs_t *structs);
int gyroreq(modular_structs_t *structs);
int pitchanglereq(modular_structs_t *structs);
int rollanglereq(modular_structs_t *structs);
int accelresp(modular_structs_t *structs);

// TODO add in string to be read from the command line when sending a subtype of message
extern struct MessageType MessageTypes[MAX_TYPE];

#endif
